// This header file is free for any kind of use commercial or non by any party.

// Author: Conor Stokes
// Purpose: Simple AABB tree implementation

#ifndef _HaabbtreeH_
#define _HaabbtreeH_

// AABB node for AABB tree
class CAABBNode {
	CAABB m_box; // node's bounding box
	CAABBNode* m_children[2]; // child nodes of this node	
	list<CTriangle> m_triangles; // triangles in this node
public:
	// heuristic struct, passed down the tree
	struct Heuristic {
		UINT8 maxdepth; // maximum depth
		UINT32 mintricnt; // minimum triangle count 
		UINT32 tartricnt; // target triangle count
		float minerror; // minimum error required
	};
	
	// constructs this aabb tree node from a triangle list and creates its children recursively
	CAABBNode(list<CTriangle>& trilist,UINT32 depth,const Heuristic& heurdata);
	// destructs this node 
	~CAABBNode();
	// renders tris that collide with the sphere
	void RenderCollideTris(const CSphere& testsphere) const;
};

#endif